var slideshow = new function()
{
    var _config = {};
    _config.dataId          = 'slideshow_data';
    _config.minDuration     = 1000*6;
    _config.fadeDuration    = 1500;
    _config.updateDelay     = 50;
    _config.maxUpScale      = 1;
    _config.imageVersion    = 'preview';
    

    var that        = this;
    var _capable    = typeof(document.getElementsByTagName)==='function';
    var _index      = 0;
    var _img        = document.getElementById( 'slideshowImage' );
    var _next       = new Image();
    var _prev       = -1;
    

    /** 
     *  starts the slideshow
     */
    this.start  = function()
    {
        _index  = that.album.index||0;
        var img = that.album.images;
        
        _next.src   = document.getElementById( 'imagePreviewImage' ).src;

        _img.parentNode.style.display = 'block';
        _nextImage();
        that.timeStart     = new Date().getTime();
        that.on =   true;

        document.body.onkeypress =  slideshow.stop;
    }
    
    /** 
     *  stop slideshow and go to the page showing the current image
     */
    this.stop   = function()
    {
        that.on =   false;
        _img.parentNode.style.display = '';

        //  go to the current image
        var img = that.album.images;
        location.href   = unescape( that.album.path+ img[ (_index+img.length-1)%img.length ] ) +'/view';
    }
    
    /**
     *  switch and resize the current image, and preload the next one
     */
    function _nextImage()
    {
        var img = that.album.images;
    	var _style   = _img.style;
        
        
        var scaling = Math.min( _img.parentNode.offsetWidth/_next.width*.9, _img.parentNode.offsetHeight/_next.height*.9, _config.maxUpScale );

        var w   = Math.round( _next.width *scaling )&-2;
        var h   = Math.round( _next.height*scaling )&-2;
        
    	_style.opacity      = 0;
    	_style.filter       = 'alpha(opacity=0)';
        _img.src            = _next.src;
        _style.width        = w +'px';
        _style.height       = h +'px';
        _style.marginTop    = -h/2 +'px';
        _style.marginLeft   = -w/2 +'px';
        
        _index++;
        _next.src   = unescape( that.album.path+ img[ _index%img.length ] ) +'/'+ _config.imageVersion;

        that.timeLastImage = new Date().getTime();
    }
    
    /**
     *  update the opacity of the image and check whether we need to proceed to the next image
     */
    this.update = function()
    {
        if( that.on )
        {
            var time    = new Date().getTime();
            var timeRel = time-that.timeLastImage;
            var i       = 0;
            var next    = false;
        	var style   = _img.style;

            var i = (_config.fadeDuration-timeRel+_config.minDuration)/_config.fadeDuration;
            if( i<=0 )
            {
                next = true;
            }
    
        	i = Math.min( 1.0, Math.max( 0, i ) );

        	if( Math.abs( i-_prev )>1/32 || (_prev<1 && i==1) || (_prev>0 && i==0) )
        	{
            	style.opacity   = i;
            	style.filter    = 'alpha(opacity='+ i*100 +')';
            	_prev           = i;
            }
    
            if( next )
            {
                _nextImage();
            }
        }
        setTimeout( that.update, _config.updateDelay );
    }
    setTimeout( that.update, 1 );

}()